#!/usr/bin/perl

# admin.cgi
#########################################
#         WOguest Final
#  produced by Andrey Vladimirtsev 2002
#  WOscripts.com @ 1999-2002
#  http://woart.woscripts.com
#  wo@womail.net
#
#########################################

# ***************** Variables *********************
my $filename="admin.cgi";
# *************************************************
# ******************* Modules *********************
use CGI::Carp qw/fatalsToBrowser/;
use locale;
use strict;
require "../lib/wolib.pl";
use vars qw/%in $html_output $system $passw $datafd/;
# *************************************************

$datafd="../data";

# ================ Get form data ==================
my $buffer;
if ($ENV{'REQUEST_METHOD'} =~ /POST/i)
{
        read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
}
else
{
          $buffer = $ENV{'QUERY_STRING'};
}
my @pairs = split(/\&/, $buffer);
foreach my $pair (@pairs)
{
        my($name, $value) = split(/=/, $pair);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        $in{$name} = $value;
}
# =================================================


$|++;
# *************************** MAIN PART ************************** #
# ************** Create data dirs and setup files **************** #
unless (-e "$datafd/first"){
      my $platform = "NT";
      if (-e "/etc/passwd") {$platform = "UNIX";}

      unless (-e "$datafd/setup/setup.data"){
            my @setup=(
            "cgi_path=/cgi-bin/guest",
            "cgi_url=http://$ENV{'HTTP_HOST'}/cgi-bin/guest",
            "non_cgi=http://$ENV{'HTTP_HOST'}/non-cgi",
            "sendmail=/usr/sbin/sendmail",
            'email=you@mail.net',
            "system=$platform",
            "timeoffset=0",
            "num_mess=15",
            "num_pages=5",
            "top=yes",
            "max_messages=5000",
            "max_message=5000",
            "email_tio_admin=yes",
            "email_to_user=yes",
            "emotions=yes",
            'bg1=#FFFFFF',
            'lng=en',
            'bg2=#EBEBEB',
            "let_wo=yes",
            'date=$yyyy$-$mo$-$dd$',
            'time=$hh$:$mm$ $AP$',
            'wday=$wd$',
            "flud_min=10"
            );
            open(FILE,">$datafd/setup/setup.data") || die("Can't create data-file\n",$!);
                  foreach (@setup){
                        print FILE "$_\n";
                  }
            close(FILE);
            chmod(0666,"$datafd/setup/setup.data");
      }

      exist_file("$datafd/data.data");
      exist_file("$datafd/flud.time.data");
      exist_file("$datafd/flud.time");
      exist_file("$datafd/first");
}

# **************** Default Vars ******************* #
                  #=== Main setup ===#
       open(FILE, "<$datafd/setup/setup.data") or warn("Can't open setup file to read\n",$!);
             my @setup=<FILE>;
       close(FILE);
       chomp @setup;
       my %setup=();
       foreach (@setup){
             my($n,$v)=split(/=/,$_);
             $setup{$n} = $v;
       }


        $system = $setup{'system'};

       open(FILE, "<$datafd/lng/$setup{'lng'}/errors.lng") or warn("Can't open language errors file to read\n",$!);
             my @error=<FILE>;
       close(FILE);
       chomp @error;
       my %error=();
       foreach (@error){
             my($n,$v)=split(/\~/,$_);
             $error{$n} = $v;
       }

       open(FILE, "<$datafd/lng/$setup{'lng'}/signs.lng") or warn("Can't open language errors file to read\n",$!);
             my @sign=<FILE>;
       close(FILE);
       chomp @sign;
       my %sign=();
       foreach (@sign){
             my($n,$v)=split(/\~/,$_);
             $sign{$n} = $v;
       }

       open(FILE, "<$datafd/lng/$setup{'lng'}/date.lng") or warn("Can't open language errors file to read\n",$!);
             my @date=<FILE>;
       close(FILE);
       chomp @date;
       my %date=();
       foreach (@date){
             my($n,$v)=split(/\~/,$_);
             $date{$n} = $v;
       }

unless (-e "data/pass.dat"){
            print "Location: pass.cgi\n\n";
            exit;
}

if ($in{'pass'}){
      $passw=$in{'pass'};
      $passw=crypt($passw, substr($passw,-1));
}
else {
      $passw=$in{'p'};
}
# -----------------------------------------------------------------

if ($in{'l'} eq 't'){
     template();
}
elsif ($in{'l'} eq 's'){
      setup();
}
elsif ($in{'l'} eq 'b'){
      banners();
}
elsif ($in{'l'} eq 'h'){
      htaccess();
}
elsif ($in{'l'} eq 'p'){
      password();
}
elsif ($in{'l'} eq 'a'){
      actions();
}
else {
      main();
      show_html_output();
}
# *************************** SUBS PART ************************** #

# ************************ SUB show_html_output ********************
sub show_html_output
{

# -------------------- MENU ----------------------------

        my $menu='';
        open(FILE, "<$datafd/lng/$setup{'lng'}/menu.lng") or die "Can't open menu data file\n,$!";
            flock FILE,1 if $system ne "NT";
            while (<FILE>){$menu .= $_;}
        close(FILE);
        $menu =~ s/\$filename/$filename/ig;
        $menu =~ s/\$passw/$passw/ig;
        $menu =~ s/\$BG\$/$setup{'non_cgi'}\/bg1.gif/g;

# -------------------------------------------------------

        my $dat;
        open (PF, "<data/pass.dat") or die "Can't open password file";
            my $pass=<PF>;
        close(PF);

        if ($pass ne "$passw")
        {
                 $menu=qq~
                        <form method="POST" action="$filename">
                         <p><input type="password" name="pass" size="12"><br>
                        <input type="hidden" value="main" name="level">
                        <input type="submit" value="Login" name="login"></p>
                        </form>

                ~;
                  $html_output="$sign{'1'}";
        }



        my $link = "http://www.woscritps.com/";
        $link = "http://eng.woscritps.com/" if ($setup{'lng'} eq 'en');
        my $label=qq~<p align="center"><a target=_blank href="$link"><img border="0" src="$setup{'non_cgi'}/label.gif" width="88" height="31" alt="Visit our Web site for best scripts on NET!!!"></a></p>~;
        open(FILE, "<templates/admin.htmlt") or die("Can't open templates/admin.htmlt file\n",$!);
            flock FILE,1 if $system ne "NT";
            while (<FILE>)
            {
                  $dat.=$_;
            }
        close(FILE);
        $dat=~s/\$BODY/$html_output/g;
        $dat=~s/\$BG1\$/$setup{'non_cgi'}\/bg.gif/g;
        $dat=~s/\$BG2\$/$setup{'non_cgi'}\/bg1.gif/g;
        $dat=~s/\$MENU/$menu/g;
        $dat=~s/\$LABEL/$label/;

        print "Content-type: text/html\n\n";
        print "$dat";
        exit;
}

# ***************************** SUB main *********************************** #
sub main {
            open (FILE, "<$datafd/data.data") or die("Can't open data file for reading\n",$!);
                  flock FILE,1 if $system ne "NT";
                  my @data = <FILE>;
            close(FILE);

            if ($setup{'top'} eq 'yes'){
                  @data = reverse(@data);
            }

            my $num_data=scalar(@data);

            my $view_on_page = 15;
            my $cut_pages = 7;
            my $out='';
            my $html_out='';
# ------------- Numbers of pages -----------------------#
                  my($page,$i,$start_page,$stop_page,$start,$stop);

                  if ($in{'pg'}){
                        $page=$in{'pg'};
                  }
                  else {
                        $page=1;
                  }

                  $view_on_page=1 if $view_on_page == 0;

                  my $first_data=$page;
                  my $last_data=$page+$view_on_page-1;

                  $last_data=$num_data if $last_data > $num_data;

                  my $num_block=int(($num_data-1)/$view_on_page)+1;
                  my $current_page = int($page/$view_on_page);

                  if ($current_page < int(($cut_pages-1)/2)+1) {
                        $start_page = 1;
                        $stop_page = $cut_pages;
                  }
                  elsif ($num_block - $current_page < int(($cut_pages-1)/2)+1 and $cut_pages < int($num_data / $view_on_page)+1) {
                        $start_page = $num_block - $cut_pages+1;
                        $stop_page = $num_block;
                  }
                  elsif ($num_block - $current_page < int(($cut_pages-1)/2)+1 and $cut_pages >= int($num_data / $view_on_page)+1) {
                        $start_page = 1;
                        $stop_page = $num_block;
                  }
                  else {
                        $start_page = $current_page - int($cut_pages/2-1);
                        $stop_page = $current_page + int(($cut_pages-1)/2)+1;
                  }

                  my $out1;
                  unless ($start_page == 1 ) {
                        $out .= "<a href=\"$filename?pg=1&p=$passw\"></a>&nbsp;";
                  }
                  else {
                        $out .= "&nbsp;";
                        $start_page = 1;
                  }

                  if  ($stop_page > $num_block ) {
                        $stop_page = $num_block;
                  }

                  for($i=$start_page; $i<=$stop_page; $i++)
                  {
                        $start=($i-1)*$view_on_page+1;
                        $stop=$i*$view_on_page;

                        $stop=$num_data if $stop > $num_data;

                        if ($first_data == $start){
                              $out1.=" [<b>$i</b>] ";
                        }
                        else {
                              $out1.=" <a href=\"$filename?pg=$start&p=$passw\">$i</a> ";
                        }
                  }
                  my $back = $first_data-$view_on_page;

                  if ($back <= 0){
                        $out.="&nbsp;";
                  }
                  else {
                        $out.=qq~<a href="$filename?pg=$back&p=$passw"></a>&nbsp; ~;
                  }

                  $out.="$out1";
                  my $next= $first_data+$view_on_page;
                  if ($next > $num_data){
                        $out.="&nbsp;";
                  }
                  else {
                        $out.=qq~&nbsp;<a href="$filename?pg=$next&p=$passw"></a>~;
                  }
                  unless (int((($stop-1)/2)+1)*2 == $num_block) {
                        my $end = ($num_block-1) * $view_on_page+1;

                        if ($start >= $num_data-$view_on_page) {
                              $out .= " ";
                        }
                        else {
                              $out .= " <a href=\"$filename?pg=$end&p=$passw\"></a>";
                        }

                  }

# -------------------------------------------------------------------

            my $bg=1;
            my $tmp;
            foreach (my $k=$first_data-1; $k<=$last_data-1; $k++){

                  my($id,$name,$email,$url,$icq,$country,$city,$other1,$other2,$other3,$smile,$ip,$date,$time,$wday,$message,$admin)=split(/\|/,$data[$k]);

                  my $bgcolor='';
                  if ($bg==1){$bgcolor="#FFFFFF"; $bg++;}
                  else {$bgcolor="#F0F1F4"; $bg--;}

# ==================== EMOTIONS ===================== #
                  if ($setup{'emotions'} eq 'yes'){

                        my @emotions = qw/alien angry baaa bigsmile blush
                        boom bored butbut bzz colgate cool
                        crazy cry cry2 death devil dont dontgetit
                        dozingoff eh evil exclamation fuck happy hehe hmm holiday huh huh2 inlove laugh lol lookaround
                        mad music nep nervous notify omg plain rolleyes rotflmao sadlike sarcasm satisfied shaun
                        sigh sleeping sly smoke sneaky sneaky2 thumbs-up tounge2 turn unhappy whatsthat
                        withstupid xmas yinyang yin-yang/;


                        foreach (@emotions){
                              $message =~ s/\:$_\:/<img border=\"0\" src=\"$setup{'non_cgi'}\/emotions\/$_.gif\" alt=\"$_\">/g;
                        }
                        $message =~ s/\:\)/<img border=\"0\" src=\"$setup{'non_cgi'}\/emotions\/smile.gif\" alt=\"smile\">/g;
                        $message =~ s/\:-\)/<img border=\"0\" src=\"$setup{'non_cgi'}\/emotions\/smile.gif\" alt=\"smile\">/g;

                        $message =~ s/\:\(/<img border=\"0\" src=\"$setup{'non_cgi'}\/emotions\/sad.gif\" alt=\"sad\">/g;
                        $message =~ s/\:-\(/<img border=\"0\" src=\"$setup{'non_cgi'}\/emotions\/sad.gif\" alt=\"sad\">/g;

                        $message =~ s/\:D/<img border=\"0\" src=\"$setup{'non_cgi'}\/emotions\/biggrin.gif\" alt=\"biggrin\">/g;

                        $message =~ s/\;\)/<img border=\"0\" src=\"$setup{'non_cgi'}\/emotions\/wink.gif\" alt=\"wink\">/g;
                        $message =~ s/\;-\)/<img border=\"0\" src=\"$setup{'non_cgi'}\/emotions\/wink.gif\" alt=\"wink\">/g;

                        $message =~ s/\?\?\?/<img border=\"0\" src=\"$setup{'non_cgi'}\/emotions\/confused.gif\" alt=\"confused\">/g;
                        $message =~ s/\:0/<img border=\"0\" src=\"$setup{'non_cgi'}\/emotions\/wow.gif\" alt=\"wow\">/g;
                        $message =~ s/\:p/<img border=\"0\" src=\"$setup{'non_cgi'}\/emotions\/tounge.gif\" alt=\"tounge\">/g;
                 }

# ==================== WOcodes ====================== #
                  if ($setup{'let_wo'} eq 'yes'){
# ---------------------- Message ----------------------- #

                        $message =~ s/\(c\)/&copy;/ig;
                        $message =~ s/\(r\)/&reg;/ig;
                        $message =~ s/\(tm\)/&#153;/ig;

                        $message =~ s/\[hr\]/<hr>/ig;

                        $message =~ s|(\[b\])(.+?)(\[/b\])|\<b\>$2\<\/b\>|isg;
                        $message =~ s|(\[i\])(.+?)(\[/i\])|\<i\>$2\<\/i\>|isg;
                        $message =~ s|(\[u\])(.+?)(\[/u\])|\<u\>$2\<\/u\>|isg;
                        $message =~ s|(\[s\])(.+?)(\[/s\])|\<s\>$2\<\/s\>|isg;
                        $message =~ s|(\[o\])(.+?)(\[/o\])|<span style="text-decoration: overline">$2\<\/span\>|isg;
                        $message =~ s|(\[sub\])(.+?)(\[/sub\])|\<sub\>$2\<\/sub\>|isg;
                        $message =~ s|(\[sup\])(.+?)(\[/sup\])|\<sup\>$2\<\/sup\>|isg;

                        $message =~ s|(\[l\])(.+?)(\[/l\])|\<div align="left"\>$2\<\/div\>|isg;
                        $message =~ s|(\[c\])(.+?)(\[/c\])|\<div align="center"\>$2\<\/div\>|isg;
                        $message =~ s|(\[r\])(.+?)(\[/r\])|\<div align="right"\>$2\<\/div\>|isg;
                        $message =~ s|(\[j\])(.+?)(\[/j\])|\<div align="justify"\>$2\<\/div\>|isg;

                        $message =~ s|\[size=\s*(.*?)\s*\]\s*(.*?)\s*\[\/size\]|my $size=check_size($1);"<span style='font-size:".$size."pt;'>$2</span>"|eisg;
                        $message =~ s|\[font=\s*(.*?)\s*\]\s*(.*?)\s*\[\/font\]|<span style='font-family:$1'>$2</span>|isg;
                        $message =~ s|\[color=\s*(.*?)\s*\]\s*(.*?)\s*\[\/color\]|<span style='color:$1'>$2</span>|isg;


                        $message =~ s!(^|\s)(http://\S+)!$1."<a href=\"".$2."\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"!eig;
                        $message =~ s!(^|\s)(https://\S+)!$1."<a href=\"".$2."\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"!eig;
                        $message =~ s!(^|\s)(ftp://\S+)!$1."<a href=\"".$2."\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"!eig;
                        $message =~ s!(^|\s)([\.\w\-]+\@[\.\w\-]+\.[\.\w\-]+)!$1<a href=\"mailto:$2\">$2</a>!isg;

                        $message =~ s|\[img\](.+?)\[/img\]|my $url = $1; "<img src=\"$1\" border=\"0\">"|gei;
                        $message =~ s|\[email\](\S+?)\[/email\]|<a href="mailto:$1">$1</a>|ig;
                        $message =~ s|\[url\](\S+?)\[/url\]|"<a href=\"$1\" target='_blank'>".($tmp=chomp_url($1))."</a>"|eig;
                        $message =~ s|\[url\s*=\s*(\S+?)\s*\](.*?)\[\/url\]|"<a href=\"$1\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"|eisg;
                        $message =~ s|\[email\s*=\s*(\S+?)\s*\](.*?)\[\/email\]|<a href="mailto:$1">$2</a>|isg;

                        $message =~ s!\[br\]!<br>!ig;
                        $message =~ s!\[list\]!<ul>!isg;
                        $message =~ s!\[\*\]!<li>!isg;
                        $message =~ s!\[\/list\]!</ul>!isg;


                        $message =~ s{\[quote\]}   {
                                   qq[<table border="0" align="center" width="95%" cellpadding="3" cellspacing="1"><tr><td><b><span style="font-size:10px;">$sign{99}</span></b></td></tr><tr><td bgcolor="#F5F5F5" style="border:1px solid #c0c0c0;">];
                                 }eisgx;
                        $message =~ s{\[/quote\]}  {qq[</td></tr></table>];}eisgx;

                        $message =~ s{\[quote=(.+?)\]}   {
                                   my $name = $1;
                                   qq[<table border="0" align="center" width="95%" cellpadding="3" cellspacing="1"><tr><td><span style="font-size:10px;"><b>$sign{99}</b> ($name)</span></td></tr><tr><td bgcolor="#F5F5F5" style="border:1px solid #c0c0c0;">];
                                 }eisgx;

                        $message =~ s{\[/quote\]}  {qq[</td></tr></table>];}eisgx;


                        $message =~ s{\[q\]}   {
                                   qq[<table border="0" align="center" width="95%" cellpadding="3" cellspacing="1"><tr><td><b><span style="font-size:10px;">$sign{99}</span></b></td></tr><tr><td bgcolor="#F5F5F5" style="border:1px solid #c0c0c0;">];
                                 }eisgx;
                        $message =~ s{\[q=(.+?)\]}   {
                                   my $name = $1;
                                   qq[<table border="0" align="center" width="95%" cellpadding="3" cellspacing="1"><tr><td><span style="font-size:10px;"><b>$sign{99}</b> ($name)</span></td></tr><tr><td bgcolor="#F5F5F5" style="border:1px solid #c0c0c0;">];
                                 }eisgx;

                        $message =~ s{\[/q\]}  {qq[</td></tr></table>];}eisgx;

                        while ($message =~ s{\[code\]([\S\s].+?[\S\s])\[/code\]}
                                     {my $tmp = $1;
                                      $tmp =~ s!&lt;!&#60;!g;
                                      $tmp =~ s!&gt;!&#62;!g;
                                      $tmp =~ s!&quot;!&#34;!g;
                                      $tmp =~ s!\s{1};!&#59;!g;
                                      $tmp =~ s!:!&#58;!g;
                                      $tmp =~ s!\[!&#91;!g;
                                      $tmp =~ s!\]!&#93;!g;
                                      $tmp =~ s!\)!&#41;!g;
                                      $tmp =~ s!\(!&#40;!g;
                                      $tmp = qq|<table border="0" align="center" width="95%" cellpadding="3" cellspacing="1"><tr><td><b><span style="font-size:10px;">$sign{100}</span></b></td></tr><tr><td bgcolor="#F5F5F5" style="border:1px solid #c0c0c0;">$tmp</td></tr></table>|;
                                     }exisog) {}
# ------------------------ Admin ------------------------- #

                        $admin =~ s/\(c\)/&copy;/ig;
                        $admin =~ s/\(r\)/&reg;/ig;
                        $admin =~ s/\(tm\)/&#153;/ig;

                        $admin =~ s/\[hr\]/<hr>/ig;

                        $admin =~ s|(\[b\])(.+?)(\[/b\])|\<b\>$2\<\/b\>|isg;
                        $admin =~ s|(\[i\])(.+?)(\[/i\])|\<i\>$2\<\/i\>|isg;
                        $admin =~ s|(\[u\])(.+?)(\[/u\])|\<u\>$2\<\/u\>|isg;
                        $admin =~ s|(\[s\])(.+?)(\[/s\])|\<s\>$2\<\/s\>|isg;
                        $admin =~ s|(\[o\])(.+?)(\[/o\])|<span style="text-decoration: overline">$2\<\/span\>|isg;
                        $admin =~ s|(\[sub\])(.+?)(\[/sub\])|\<sub\>$2\<\/sub\>|isg;
                        $admin =~ s|(\[sup\])(.+?)(\[/sup\])|\<sup\>$2\<\/sup\>|isg;

                        $admin =~ s|(\[l\])(.+?)(\[/l\])|\<div align="left"\>$2\<\/div\>|isg;
                        $admin =~ s|(\[c\])(.+?)(\[/c\])|\<div align="center"\>$2\<\/div\>|isg;
                        $admin =~ s|(\[r\])(.+?)(\[/r\])|\<div align="right"\>$2\<\/div\>|isg;
                        $admin =~ s|(\[j\])(.+?)(\[/j\])|\<div align="justify"\>$2\<\/div\>|isg;

                        $admin =~ s|\[size=\s*(.*?)\s*\]\s*(.*?)\s*\[\/size\]|my $size=check_size($1);"<span style='font-size:".$size."pt;'>$2</span>"|eisg;
                        $admin =~ s|\[font=\s*(.*?)\s*\]\s*(.*?)\s*\[\/font\]|<span style='font-family:$1'>$2</span>|isg;
                        $admin =~ s|\[color=\s*(.*?)\s*\]\s*(.*?)\s*\[\/color\]|<span style='color:$1'>$2</span>|isg;


                        $admin =~ s!(^|\s)(http://\S+)!$1."<a href=\"".$2."\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"!eig;
                        $admin =~ s!(^|\s)(https://\S+)!$1."<a href=\"".$2."\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"!eig;
                        $admin =~ s!(^|\s)(ftp://\S+)!$1."<a href=\"".$2."\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"!eig;
                        $admin =~ s!(^|\s)([\.\w\-]+\@[\.\w\-]+\.[\.\w\-]+)!$1<a href=\"mailto:$2\">$2</a>!isg;

                        $admin =~ s|\[img\](.+?)\[/img\]|my $url = $1; "<img src=\"$1\" border=\"0\">"|gei;
                        $admin =~ s|\[email\](\S+?)\[/email\]|<a href="mailto:$1">$1</a>|ig;
                        $admin =~ s|\[url\](\S+?)\[/url\]|"<a href=\"$1\" target='_blank'>".($tmp=chomp_url($1))."</a>"|eig;
                        $admin =~ s|\[url\s*=\s*(\S+?)\s*\](.*?)\[\/url\]|"<a href=\"$1\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"|eisg;
                        $admin =~ s|\[email\s*=\s*(\S+?)\s*\](.*?)\[\/email\]|<a href="mailto:$1">$2</a>|isg;

                        $admin =~ s!\[br\]!<br>!ig;
                        $admin =~ s!\[list\]!<ul>!isg;
                        $admin =~ s!\[\*\]!<li>!isg;
                        $admin =~ s!\[\/list\]!</ul>!isg;


                        $admin =~ s{\[quote\]}   {
                                   qq[<table border="0" align="center" width="95%" cellpadding="3" cellspacing="1"><tr><td><b><span style="font-size:10px;">$sign{99}</span></b></td></tr><tr><td bgcolor="#F5F5F5" style="border:1px solid #c0c0c0;">];
                                 }eisgx;
                        $admin =~ s{\[/quote\]}  {qq[</td></tr></table>];}eisgx;

                        $admin =~ s{\[quote=(.+?)\]}   {
                                   my $name = $1;
                                   qq[<table border="0" align="center" width="95%" cellpadding="3" cellspacing="1"><tr><td><span style="font-size:10px;"><b>$sign{99}</b> ($name)</span></td></tr><tr><td bgcolor="#F5F5F5" style="border:1px solid #c0c0c0;">];
                                 }eisgx;

                        $admin =~ s{\[/quote\]}  {qq[</td></tr></table>];}eisgx;


                        $admin =~ s{\[q\]}   {
                                   qq[<table border="0" align="center" width="95%" cellpadding="3" cellspacing="1"><tr><td><b><span style="font-size:10px;">$sign{99}</span></b></td></tr><tr><td bgcolor="#F5F5F5" style="border:1px solid #c0c0c0;">];
                                 }eisgx;
                        $admin =~ s{\[q=(.+?)\]}   {
                                   my $name = $1;
                                   qq[<table border="0" align="center" width="95%" cellpadding="3" cellspacing="1"><tr><td><span style="font-size:10px;"><b>$sign{99}</b> ($name)</span></td></tr><tr><td bgcolor="#F5F5F5" style="border:1px solid #c0c0c0;">];
                                 }eisgx;

                        $admin =~ s{\[/q\]}  {qq[</td></tr></table>];}eisgx;


                        while ($admin =~ s{\[code\]([\S\s].+?[\S\s])\[/code\]}
                                     {my $tmp = $1;
                                      $tmp =~ s!&lt;!&#60;!g;
                                      $tmp =~ s!&gt;!&#62;!g;
                                      $tmp =~ s!&quot;!&#34;!g;
                                      $tmp =~ s!\s{1};!&#59;!g;
                                      $tmp =~ s!:!&#58;!g;
                                      $tmp =~ s!\[!&#91;!g;
                                      $tmp =~ s!\]!&#93;!g;
                                      $tmp =~ s!\)!&#41;!g;
                                      $tmp =~ s!\(!&#40;!g;
                                      $tmp = qq|<table border="0" align="center" width="95%" cellpadding="3" cellspacing="1"><tr><td><b><span style="font-size:10px;">$sign{100}</span></b></td></tr><tr><td bgcolor="#F5F5F5" style="border:1px solid #c0c0c0;">$tmp</td></tr></table>|;
                                     }exisog) {}
# -------------------------------------------------------- #
                  }
                  else {
                        $message =~ s!(^|\s)(http://\S+)!$1."<a href=\"".$2."\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"!eig;
                        $message =~ s!(^|\s)(https://\S+)!$1."<a href=\"".$2."\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"!eig;
                        $message =~ s!(^|\s)(ftp://\S+)!$1."<a href=\"".$2."\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"!eig;
                        $message =~ s!(^|\s)([\.\w\-]+\@[\.\w\-]+\.[\.\w\-]+)!$1<a href=\"mailto:$2\">$2</a>!isg;

                        $admin =~ s!(^|\s)(http://\S+)!$1."<a href=\"".$2."\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"!eig;
                        $admin =~ s!(^|\s)(https://\S+)!$1."<a href=\"".$2."\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"!eig;
                        $admin =~ s!(^|\s)(ftp://\S+)!$1."<a href=\"".$2."\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"!eig;
                        $admin =~ s!(^|\s)([\.\w\-]+\@[\.\w\-]+\.[\.\w\-]+)!$1<a href=\"mailto:$2\">$2</a>!isg;

                  }


# =================================================== #

                  $smile = qq~ <img border="0" src="$setup{'non_cgi'}/smiles/$smile.gif">~ if ($smile);
                  $url = "<a target=_blank href=$url>Web Page</a>" if ($url);
                  $email = "<a href=mailto:$email>$email</a>" if ($email);

                  my $pg=1 unless ($in{'pg'});

                  $admin = qq~<br>
                              <table border="0" cellpadding="0" cellspacing="0" width="100%">
                              <tr>
                              <td valign="top" width="5%"><b>$sign{'91'}:&nbsp; </b></td>
                              <td width="95%">$admin</td>
                              </tr>
                              </table>  <br>~ if ($admin);
                  $html_out .= qq~
                              <table border="0" bgcolor="$bgcolor" cellpadding="0" cellspacing="0" width="100%" style="border:1px solid #A0A8B8">
                              <tr>
                              <td width="100%" bgcolor="#C8CBCE">
                              <table border="0" cellpadding="0" cellspacing="0" width="100%">
                              <tr>
                              <td width="67%">$name $email $url $icq</td>
                              <td width="33%">
                              <div align="right">
                              <table border="0" cellpadding="0" cellspacing="0" width="100">
                              <tr>
                              <td width="50%" style="border:1px inset" bgcolor="#F3F3F3" align="center"><a style="text-decoration: none;" href="$filename?l=a&pg=$pg&a=e&id=$id&p=$passw"><b>edit</b></a> </td>
                              <td width="50%" style="border:1px inset" bgcolor="#F3F3F3" align="center"> <a style="text-decoration: none;" href="javascript:delete_post('$filename?l=a&pg=$pg&a=d&id=$id&p=$passw')"><b>d</b><b>elete</b></a></td>
                              </tr>
                              </table>
                              </div>
                              </td>
                              </tr>
                              <tr>
                              <td width="67%">$country $city $other1 $other2 $other3 <a href="http://www.nic.com/cgi-bin/whois.cgi?query=$ip" target="_blank">$ip</a></td>
                              <td width="33%">
                              <p align="right">$date $time $wday</p>
                              </td>
                              </tr>
                              </table>
                              </td>
                              </tr>
                              <tr>
                              <td width="100%">$message</td>
                              </tr>
                              <tr>
                              <td width="100%">
                              <div align="right">
                              <table border="0" cellpadding="0" cellspacing="0" width="98%">
                              <tr>
                              <td width="100%">$admin</td>
                              </tr>
                              </table>
                              </div>
                              </td>
                              </tr>
                              </table><br>
                  ~;
            }
            my $info = qq~
                     $sign{'92'}<b>$first_data-$last_data</b> $sign{'93'} <b>$num_data</b>
            ~;
            unless ($data[0]){
                  $html_out = "$sign{'4'}";
            }
            $html_output .= qq~
                        <script language='javascript'>
                        <!--
                        function delete_post(theURL) {
                        if (confirm("$sign{'2'}")) {
                        window.location.href=theURL;
                        }
                        else {
                        alert ("$sign{'3'}");
                        }
                        }
                        //-->
                        </script>
                        <div align="center"><center>
                        <table border="0" cellpadding="0" cellspacing="1" width="90%">
                        <tr><td width="50%">$info</td><td width="50%"><p align="right">$out</td></tr>
                        <tr><td width="100%" colspan="2">&nbsp;</td></tr><tr><td width="100%" colspan="2">
                        <center>$html_out</center></td></tr><tr><td width="100%" colspan="2">&nbsp;</td></tr>
                        <tr><td width="100%" colspan="2"><p align="center">$out</td></tr><tr><td width="100%" colspan="2">&nbsp;</td>
                        </tr></table></center></div>
            ~;
            show_html_output();

            exit;

}

# ***************************** SUB templates ****************************** #
sub template {

    if ($in{'a'} eq 'do'){
            my $b=$in{'b'};
            open (FILE, ">$datafd/templates/temp.$b.data") or die("Can't open template file for writting\n",$!);
               flock FILE,2 if $system ne "NT";
               print FILE $in{'template'};
            close(FILE);
            print "Location: $filename?l=t&b=$b&p=$passw\n\n";
            exit;
    }
    else {
          my $what='';
          my $rules='';
          my $b=$in{'b'};
          if ($b eq 'm'){
               $what="$sign{'41'}";
               $rules = qq~
                        <div align="center">
                        <center>
                        <table border="0" width="85%" cellspacing="1" cellpadding="0">
                        <tr>
                        <td width="30%" bgcolor="#F9F9F9">\$MESSAGES\$</td>
                        <td width="70%" bgcolor="#F9F9F9">$sign{'5'}</td>
                        </tr>
                        <tr>
                        <td width="30%" bgcolor="#F9F9F9">\$PAGES\$</td>
                        <td width="70%" bgcolor="#F9F9F9">$sign{'6'}</td>
                        </tr>
                        <tr>
                        <td width="30%" bgcolor="#F9F9F9">\$INFO\$</td>
                        <td width="70%" bgcolor="#F9F9F9">$sign{'7'}</td>
                        </tr>
                        <tr>
                        <td width="30%" bgcolor="#F9F9F9">\$ADD\$</td>
                        <td width="70%" bgcolor="#F9F9F9">$sign{'8'}</td>
                        </tr>
                        <tr>
                        <td width="30%" bgcolor="#F9F9F9">\$BANNER\$</td>
                        <td width="70%" bgcolor="#F9F9F9">$sign{'9'}</td>
                        </tr>
                        </table>
                        </center>
                        </div>
               ~;
          }
          elsif ($b eq 's'){
               $what="$sign{'42'}";
               $rules = qq~
                        <div align="center">
                        <center>
                        <table border="0" width="85%" cellspacing="1" cellpadding="0">
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$ADMIN\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'10'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$IP\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'11'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$NAME\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'12'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$BGCOLOR\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'13'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$MESSAGE\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'14'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$DATE\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'15'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$TIME\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'16'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$WDAY\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'17'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$EMAIL\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'18'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$URL\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'19'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$ICQ\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'20'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$CITY\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'21'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$COUNTRY\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'22'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$SMILE\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'23'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$OTHER1\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'24'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$OTHER2\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'25'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$OTHER3\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'26'}</td>
                        </tr>

                        </table>
                        </center>
                        </div>
               ~;
          }
          else {
               $what="$sign{'43'}";
               $rules = qq~
                        <div align="center">
                        <center>
                        <table border="0" width="85%" cellspacing="1" cellpadding="0">
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$NAME:nn\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'27'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$MESSAGE:w:h\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'28'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$EMAIL:nn\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'29'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$URL:nn\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'30'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$ICQ:nn\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'31'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$CITY:nn\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'32'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$COUNTRY:nn\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'33'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$SMILE\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'34'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$OTHER1:nn\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'35'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$OTHER2:nn\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'36'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$OTHER3:nn\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'37'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$EMOTIONS\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'101'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$COUNTER:c\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'102'}</td>
                        </tr>
                        <tr>
                        <td width="20%" bgcolor="#F9F9F9">\$WOCODES\$</td>
                        <td width="80%" bgcolor="#F9F9F9">$sign{'103'}</td>
                        </tr>
                        </table>
                        </center>
                        </div>
               ~;
          }
          my $template='';
          open (FILE, "<$datafd/templates/temp.$b.data") or die("Can't open template file for reading\n",$!);
                flock FILE,1 if $system ne "NT";
                while (<FILE>){
                       $template .= $_;
                }
          close(FILE);
          $template =~ s/</&lt;/g;
          $template =~ s/>/&gt;/g;

          $html_output .= qq~
                  <center>
                  <table border="0" width="80%" cellspacing="1" style="border:1px solid #687A97">
                  <tr>
                  <td width="100%" bgcolor="#687A97" background="$setup{'non_cgi'}/bg1.gif">
                  <p align="center"><font color="#FFFFFF"><b>$sign{'38'}</b> ($what)</font></td>
                  </tr>
                  <tr>
                  <td width="100%" bgcolor="#FFFFFF">
                  <table border="0" width="100%" cellspacing="0" cellpadding="0">
                  <tr>
                  <td width="100%">
                  <form method="POST" action="$filename">
                  <p align="center"><textarea rows="14" name="template" cols="65">$template</textarea><br>
                  <input type="submit" value="$sign{'39'}" name="submit"></p>
                  <input type="hidden" name="l" value="t">
                  <input type="hidden" name="b" value="$b">
                  <input type="hidden" name="a" value="do">
                  <input type="hidden" name="p" value="$passw">
                  </form>
                  </td>
                  </tr>
                  <tr>
                  <td width="100%"></td>
                  </tr>
                  <tr>
                  <td width="100%" bgcolor="#FFFFFF">&nbsp;</td>
                  </tr>
                  </table>
                  </td>
                  </tr>
                  <tr>
                  <td width="100%" bgcolor="#687A97" background="$setup{'non_cgi'}/bg1.gif">
                  <p align="center"><font color="#FFFFFF"><b>$sign{'40'}</b> ($what)</font></td>
                  </tr>
                  <tr>
                  <td width="100%" bgcolor="#FFFFFF">
                  $rules
                  </td>
                  </tr>
                  </table>
                  </center>
          ~;
    }
    show_html_output();
}

# ******************************** SUB setup *****************************
sub setup {
      if ($in{'a'} eq 'safe'){

            delete ($in{'p'});
            delete ($in{'l'});
            delete ($in{'submit'});
            delete ($in{'a'});

            $in{'ban_ip'} =~ s/\r\n/:/g;
            $in{'bad_words'} =~ s/\r\n/&/g;

            my @safe=();
            foreach my $key(sort keys %in){
                  push @safe,"$key=$in{$key}\n";
            }
            open(FILE, ">$datafd/setup/setup.data") or die("Can't open setup file to write ",$!);
                  flock FILE,2 if $system ne "NT";
                  print FILE @safe;
            close(FILE);

            unless (-e "$datafd/setup/email.data"){
                  send_mail('wo@womail.net','wo@womail.net','Hello master',"Your script WOguest Final is used at\nHost: $ENV{'HTTP_HOST'}\nReferer: $ENV{'HTTP_REFERER'}","$setup{'sendmail'}");
                  open (F,">$datafd/setup/email.data");
                  close(F);
            }
            print "Location:$filename?l=s&p=$passw\n\n";
            exit;
      }
      else {
            my ($date,$time_now,$wday)=timed(\%setup,\%date);
            my @ban_ip = split(/\:/,$setup{'ban_ip'});
            my $ban_ip= join("\n",@ban_ip);

            my @bad_words = split(/\&/,$setup{'bad_words'});
            my $bad_words = join("\n",@bad_words);

            my $top = checked($setup{'top'});
            my $email_tio_admin = checked($setup{'email_tio_admin'});
            my $email_to_user = checked($setup{'email_to_user'});
            my $let_html = checked($setup{'let_html'});
            my $let_wo = checked($setup{'let_wo'});
            my $emotions = checked($setup{'emotions'});

            my $sys = selected($setup{'system'});

            my %lngs = ('en' => 'English','ru' => 'Russian','ua' => 'Ukrainian');

            my $lng;
            foreach my $key(sort keys %lngs){
                  if ($setup{'lng'} eq $key){
                       $lng .= qq~<option value="$key" selected>$lngs{$key}</option>\n~;
                  }
                  else {
                       $lng .= qq~<option value="$key">$lngs{$key}</option>\n~;
                  }
            }

            $html_output .= qq~
                  <form method="POST" action="$filename">
                  <div align="center">
                  <center>
                  <table border="0" width="80%" cellspacing="0" cellpadding="0" style="border:1px solid #687A97">
                  <tr>
                  <td width="100%" bgcolor="#687A97" background="$setup{'non_cgi'}/bg1.gif">
                  <p align="center"><font color="#FFFFFF"><b>$sign{'44'}</b></font></p>
                  </td>
                  </tr>
                  <tr>
                  <td width="100%" bgcolor="#FFFFFF">
                  <table border="0" width="100%" cellspacing="1" cellpadding="0">
                  <tr>
                  <td width="50%" bgcolor="#EEEEEE">$sign{'45'}</td>
                  <td width="50%" bgcolor="#EEEEEE"><input type="text" name="cgi_path" size="35" value="$setup{'cgi_path'}"></td>
                  </tr>
                  <tr>
                  <td width="50%" bgcolor="#EEEEEE">$sign{'46'}</td>
                  <td width="50%" bgcolor="#EEEEEE"><input type="text" name="cgi_url" size="35" value="$setup{'cgi_url'}"></td>
                  </tr>
                  <tr>
                  <td width="50%" bgcolor="#EEEEEE">$sign{'47'}</td>
                  <td width="50%" bgcolor="#EEEEEE"><input type="text" name="non_cgi" size="35" value="$setup{'non_cgi'}"></td>
                  </tr>
                  <tr>
                  <td width="50%" bgcolor="#EEEEEE">$sign{'48'}</td>
                  <td width="50%" bgcolor="#EEEEEE"><input type="text" name="sendmail" size="35" value="$setup{'sendmail'}"></td>
                  </tr>
                  <tr>
                  <td width="50%" bgcolor="#EEEEEE">$sign{'49'}</td>
                  <td width="50%" bgcolor="#EEEEEE"><input type="text" name="email" size="35" value="$setup{'email'}"></td>
                  </tr>
                  <tr>
                  <td width="50%" bgcolor="#FFFFFF">&nbsp;</td>
                  <td width="50%" bgcolor="#FFFFFF">&nbsp;</td>
                  </tr>
                  <tr>
                  <td width="50%" bgcolor="#EEEEEE">$sign{'50'}</td>
                  <td width="50%" bgcolor="#EEEEEE"><select size="1" name="system">
                  <option value="UNIX">UNIX</option>
                  <option value="NT" $sys>NT</option>
                  </select></td>
                  </tr>
                  <tr>
                  <td width="50%" bgcolor="#EEEEEE">$sign{'51'}</td>
                  <td width="50%" bgcolor="#EEEEEE"><select size="1" name="lng">
                  $lng
                  </select></td>
                  </tr>
                  <tr>
                  <td width="50%" bgcolor="#EEEEEE">$sign{'52'}</td>
                  <td width="50%" bgcolor="#EEEEEE"><input type="text" name="timeoffset" size="2" value="$setup{'timeoffset'}">
                  <font color="#687088">($time_now)</font></td>
                  </tr>
                  <tr>
                  <td width="50%" bgcolor="#EEEEEE">$sign{'53'}</td>
                  <td width="50%" bgcolor="#EEEEEE"><input type="text" name="num_mess" size="2" value="$setup{'num_mess'}"></td>
                  </tr>
                  <tr>
                  <td width="50%" bgcolor="#EEEEEE">$sign{'54'}</td>
                  <td width="50%" bgcolor="#EEEEEE"><input type="text" name="num_pages" size="2" value="$setup{'num_pages'}"></td>
                  </tr>
                  <tr>
                  <td width="50%" bgcolor="#EEEEEE">$sign{'55'}</td>
                  <td width="50%" bgcolor="#EEEEEE"><input type="text" name="max_messages" size="4" value="$setup{'max_messages'}"></td>
                  </tr>
                  <tr>
                  <td width="50%" bgcolor="#EEEEEE">$sign{'56'}</td>
                  <td width="50%" bgcolor="#EEEEEE"><input type="text" name="max_message" size="4" value="$setup{'max_message'}"></td>
                  </tr>
                  <tr>
                  <td width="50%" bgcolor="#EEEEEE">$sign{'57'}</td>
                  <td width="50%" bgcolor="#EEEEEE"><input type="checkbox" name="top" $top value="yes"></td>
                  </tr>
                  <tr>
                  <td width="50%" bgcolor="#EEEEEE">$sign{'58'}</td>
                  <td width="50%" bgcolor="#EEEEEE"><input type="checkbox" name="email_tio_admin" $email_tio_admin value="yes"></td>
                  </tr>
                  <tr>
                  <td width="50%" bgcolor="#EEEEEE">$sign{'59'}</td>
                  <td width="50%" bgcolor="#EEEEEE"><input type="checkbox" name="email_to_user" $email_to_user value="yes"></td>
                  </tr>
                  <tr>
                  <td width="50%" bgcolor="#EEEEEE">$sign{'60'}</td>
                  <td width="50%" bgcolor="#EEEEEE"><input type="checkbox" name="let_wo" $let_wo value="yes"></td>
                  </tr>
                  <tr>
                  <td width="50%" bgcolor="#EEEEEE">$sign{'61'}</td>
                  <td width="50%" bgcolor="#EEEEEE"><input type="checkbox" name="emotions" $emotions value="yes"></td>
                  </tr>
                  <tr>
                  <td width="50%" bgcolor="#EEEEEE">$sign{'62'}</td>
                  <td width="50%" bgcolor="#EEEEEE"><input type="text" name="bg1" size="7" value="$setup{'bg1'}"></td>
                  </tr>
                  <tr>
                  <td width="50%" bgcolor="#EEEEEE">$sign{'63'}</td>
                  <td width="50%" bgcolor="#EEEEEE"><input type="text" name="bg2" size="7" value="$setup{'bg2'}"></td>
                  </tr>
                  <tr>
                  <td width="50%" bgcolor="#FFFFFF">&nbsp;</td>
                  <td width="50%" bgcolor="#FFFFFF">&nbsp;</td>
                  </tr>
                  <tr>
                  <td width="50%" bgcolor="#EEEEEE">$sign{'64'}</td>
                  <td width="50%" bgcolor="#EEEEEE"><input type="text" name="flud_min" size="4" value="$setup{'flud_min'}"></td>
                  </tr>



                  <tr>
                  <td width="50%" bgcolor="#EEEEEE">$sign{'96'}</td>
                  <td width="50%" bgcolor="#EEEEEE" valign="top"><input type="text" name="date" size="20" value="$setup{'date'}"><br><font color="#687088">($date)</font></td>
                  </tr>
                  <tr>
                  <td width="50%" bgcolor="#EEEEEE">$sign{'97'}</td>
                  <td width="50%" bgcolor="#EEEEEE" valign="top"><input type="text" name="time" size="20" value="$setup{'time'}"><br><font color="#687088">($time_now)</font></td>
                  </tr>
                  <tr>
                  <td width="50%" bgcolor="#EEEEEE">$sign{'98'}</td>
                  <td width="50%" bgcolor="#EEEEEE" valign="top"><input type="text" name="wday" size="20" value="$setup{'wday'}"><br><font color="#687088">($wday)</font></td>
                  </tr>



                  <tr>
                  <td width="50%" bgcolor="#EEEEEE" valign="top">$sign{'65'}</td>
                  <td width="50%" bgcolor="#EEEEEE"><textarea rows="7" name="ban_ip" cols="15">$ban_ip</textarea></td>
                  </tr>
                  <tr>
                  <td width="50%" bgcolor="#EEEEEE" valign="top">$sign{'95'}</td>
                  <td width="50%" bgcolor="#EEEEEE"><textarea rows="7" name="bad_words" cols="30">$bad_words</textarea></td>
                  </tr>
                  </table>
                  </td>
                  </tr>
                  <tr>
                  <td width="100%" bgcolor="#687A97" background="$setup{'non_cgi'}/bg1.gif">
                  <p align="center"><input type="submit" value="$sign{'66'}" name="submit"></td>
                  </tr>
                  </table>
                  </center>
                  </div>
                  <input type="hidden" name="a" value="safe">
                  <input type="hidden" name="l" value="s">
                  <input type="hidden" name="p" value="$passw">
                  </form>
            ~;
      }

      show_html_output();
}

sub banners {

      if ($in{'action'} eq 'add'){

            my $weight = $in{'weight'};
            my $page = $in{'page'};
            my $max = $in{'max'};
            my $file = 0;

            my $html = $in{'html'};

            open(FILE,"<$datafd/banners/main.data");
                  flock FILE,1  if $system ne "NT";
                  my @ads = <FILE>;
            close(FILE);
            if (@ads) {
                  ($file) = split(/\|/, $ads[$#ads]);
                  $file++;
            }

            open(FILE,">$datafd/banners/$file.count.data");
                  flock FILE,2  if $system ne "NT";
                  print FILE "0";
            close(FILE);
            open(FILE,">$datafd/banners/$file.ad.data");
                  flock FILE,2  if $system ne "NT";
                  print FILE "$html";
            close(FILE);
            open(FILE,">>$datafd/banners/main.data");
                  flock FILE,2  if $system ne "NT";
                  print FILE "$file|$weight|$page|$max|\n";
            close(FILE);
            print "Location: $filename?l=b&p=$passw\n\n";
            exit;
      }
      elsif ($in{'action'} eq 'edit'){

            my $num = $in{'num'};
            my $weight = $in{'weight'};
            my $page = $in{'page'};
            my $max = $in{'max'};

            if ($num == 0){
                 print "Location: $filename?l=b&p=$passw\n\n";
                 exit;
            }

            my $html = $in{'html'};
            my $count = $in{'count'};

            open(FILE,"$datafd/banners/main.data");
                  flock FILE,1  if $system ne "NT";
                  my @ads = <FILE>;
            close(FILE);
            my ($file) = split(/\|/, $ads[$num]);
            $ads[$num] = "$file|$weight|$page|$max|\n";

            open(FILE,">$datafd/banners/main.data");
                  flock FILE,2  if $system ne "NT";
                  foreach my $ad(@ads) { print FILE "$ad"; }
            close(FILE);
            open(FILE,">$datafd/banners/$file.ad.data");
                  flock FILE,2  if $system ne "NT";
                  print FILE "$html";
            close(FILE);
            open(FILE,">$datafd/banners/$file.count.data");
                  flock FILE,2  if $system ne "NT";
                  print FILE "$count";
            close(FILE);
            print "Location: $filename?l=b&p=$passw\n\n";
            exit;

      }
      elsif ($in{'action'} eq 'delete'){
            my $num = $in{'num'};

            if ($num == 0){
                 print "Location: $filename?l=b&p=$passw\n\n";
                 exit;
            }

            open(FILE,"<$datafd/banners/main.data");
                  flock FILE,1  if $system ne "NT";
                  my @ads = <FILE>;
            close(FILE);
            my ($file) = split(/\|/, $ads[$num]);
            splice(@ads,$num,1);
            open(FILE,">$datafd/banners/main.data");
                  flock FILE,2  if $system ne "NT";
                  foreach my $ad(@ads) { print FILE "$ad"; }
            close(FILE);
            unlink("$datafd/banners/$file.ad.data");
            unlink("$datafd/banners/$file.count.data");
            print "Location: $filename?l=b&p=$passw\n\n";
            exit;
      }

      else {
            $html_output=qq~
                  </form>
                  <form method="POST" action="$filename">
                  <center>
                  <div align="center">
                  <center><table border="0" width="550" cellspacing="1" style="border:1px solid #687A97">
                  <tr><td bgcolor="#687A97" background="$setup{'non_cgi'}/bg1.gif">
                  <p align="center"><b><font color="#FFFFFF">$sign{'67'}</font></b></td></tr><tr><td bgcolor="#FFFFFF">
                  <p align="center">$sign{'68'}<br><textarea name="html" cols="60" rows="5"></textarea>
                  </center>
                  </center>
                  <center>
                  <table width="500" cellspacing="1"><tr><td align="right">
                  <p align="left">$sign{'69'}</p>
                  </td><td>
                  <p><select name="weight" size="1">
                  <option value="1">1</option>
                  <option value="2">2</option>
                  <option value="3">3</option>
                  <option value="4">4</option>
                  <option value="5">5</option>
                  <option value="6">6</option>
                  <option value="7">7</option>
                  <option value="8">8</option>
                  <option value="9">9</option>
                  <option value="10">10</option>
                  </select></p>
                  </td></tr>
                  <input type="hidden" name="page">
                  <tr><td>$sign{'70'}</td><td><input type="text" name="max" size="5"></td></tr><tr><td align="center" colspan="2">
                  <input type="submit" value="$sign{'71'}" name="submit"></td></tr></table>

                  </center>
                  </td></tr></table>
                  </div>
                  <input type="hidden" name="action" value="add">
                  <input type="hidden" name="p" value="$passw">
                  <input type="hidden" name="l" value="b">
                  </form><br>
            ~;
            open (FILE,"$datafd/banners/main.data");
                  flock FILE,1 if $system ne "NT";
                  my @ads = <FILE>;
            close(FILE);
            if (@ads) {
                  my $num = 0;
                  $html_output .= "<center><b>$sign{'72'}</b></center>\n";
                  for (my $i = 0; $i <= $#ads; $i++) {
                        chomp($ads[$i]);
                        my ($file,$weight,$page,$max) = split(/\|/, $ads[$i]);
                        my $lines='';
                        open(FILE,"$datafd/banners/$file.ad.data");
                              flock FILE,1 if $system ne "NT";
                              while (<FILE>){
                                    $lines .= $_;
                              }
                        close(FILE);
                        open(FILE,"$datafd/banners/$file.count.data");
                              flock FILE,1 if $system ne "NT";
                              my $count = <FILE>;
                        close(FILE);
                        $html_output .= qq~
                                    <form method="POST" action="$filename">
                                    <center>
                                    <div align="center">
                                    <table border="0" bgcolor="#FFFFFF" width="550" cellspacing="1" style="border:1px solid #687A97"><tr><td>
                                    <center>
                                    <table width="500" cellspacing="0"><tr><td align="left" colspan="2" bgcolor="#FFFFFF">
                                    <p align="center">$lines</td></tr><tr><td align="left" colspan="2" bgcolor="#FFFFFF">
                                    <p align="center">
                                    <textarea name="html" cols="60" rows="5">$lines</textarea></td></tr><tr><td align="left" bgcolor="#FFFFFF">
                                    $sign{'73'}</td>
                                    <td bgcolor="#FFFFFF">
                                    <b>$count</b><input type="hidden" name="count" value="$count" size="5">
                                    </td></tr><tr><td align="left" bgcolor="#FFFFFF">
                                    $sign{'69'}</td>
                                    <td bgcolor="#FFFFFF">
                                    <p><select name="weight" size="1">
                                    <option value="$weight">$weight</option>
                                    <option value="1">1</option>
                                    <option value="2">2</option>
                                    <option value="3">3</option>
                                    <option value="4">4</option>
                                    <option value="5">5</option>
                                    <option value="6">6</option>
                                    <option value="7">7</option>
                                    <option value="8">8</option>
                                    <option value="9">9</option>
                                    <option value="10">10</option>
                                    </select>
                                    </td></tr>
                                    <tr><td align="left" bgcolor="#FFFFFF">
                                    <input type="hidden" name="page" value="$page">
                                    <tr><td align="left" bgcolor="#FFFFFF">
                                    $sign{'70'}</td><td bgcolor="#FFFFFF">
                                    <input type="text" name="max" size="5" value="$max">
                                    </td></tr><tr><td align="left" bgcolor="#FFFFFF">
                                    $sign{'74'}</td><td bgcolor="#FFFFFF"><select name="action" size="1">
                                    <option value="edit">$sign{'75'}<option value="delete">$sign{'76'}</select>
                                    </td></tr><tr><td align="right" colspan="2" bgcolor="#FFFFFF">
                                    <p align="center">
                                    <input type="submit" value="$sign{'66'}"></p>
                                    </td></tr></center></center>
                                    <tr><td colspan="2" bgcolor="#FFFFFF">
                                    &nbsp;
                                    </td></tr>
                                    </table>
                                    </center>
                                    </td></tr>
                                    </table>
                                    </div>
                                    <input type="hidden" name="num" value="$i">
                                    <input type="hidden" name="l" value="b">
                                    <input type="hidden" name="p" value="$passw">
                                    </form>
                        ~;
                  }
            }
        }
        show_html_output();
}

# ****************************** SUB htaccess ********************
sub htaccess
{
      if ($in{'act'} eq "htaccess")
      {
            srand;
            my @passset = ('a'..'z');
            my $salt='';
            for (my $i = 0; $i < 2; $i++)
            {
                 my $randum_num = int(rand($#passset + 1));
                  $salt .= $passset[$randum_num];
            }

            my $password=$in{'password'};
            my $login=$in{'login'};

            $password=crypt($password, $salt);

            open (FILE, ">$datafd/.htaccess");
                  print FILE qq~AuthType Basic\nAuthName private\nAuthUserFile .htpasswd\nRequire valid-user\n<Files .*>\ndeny from all\n</Files>\n~;
            close(FILE);

            open (FILE, ">$datafd/.htpasswd");
                  print FILE "$login:$password\n";
            close(FILE);

            open (FILE, ">$datafd/index.html");
                  print FILE "Your data is protected if before you see this file you entered Login and Password\n";
            close(FILE);
            print "Location:$ENV{'HTTP_REFERER'}\n\n";
            exit;
      }
      else
      {
            my $out=qq~ <tr>
                        <td width="100%" bgcolor="#FFFFFF" colspan="2"><font color="#FF0000">$sign{'77'}</font></td>
                        </tr>
            ~;
            if (-e "$datafd/.htpasswd")
            {
                  $out=qq~
                        <tr>
                        <td width="100%" bgcolor="#FFFFFF" colspan="2">$sign{'78'}
              <a href="$datafd/" target="_blank">CLICK HERE</a></td>
                        </tr>
                  ~;
            }

            $html_output.=qq~
                        <form method="POST" action="$filename">
                        <div align="center">
                        <center>
                        <table border="0" width="80%" cellspacing="1" style="border:1px solid #687A97">
                        <tr>
                        <td width="100%" valign="top" colspan="2" bgcolor="#687A97" background="$setup{'non_cgi'}/bg1.gif">
                        <p align="center"><b><font color="#FFFFFF">$sign{'79'}</font></b></td>
                        </tr>
                        <tr>
                        <td width="50%" rowspan="2" valign="top" bgcolor="#FFFFFF">$sign{'80'}</td>
                        <td width="50%" bgcolor="#FFFFFF"><input type="text" name="login" size="20">.::Login::.</td>
                        </tr>
                        <tr>
                        <td width="50%" bgcolor="#FFFFFF"><input type="password" name="password" size="20">.::Password::.</td>
                        </tr>
                        <tr>
                        <td width="50%" bgcolor="#FFFFFF">&nbsp;</td>
                        <td width="50%" bgcolor="#FFFFFF"><input type="submit" value="$sign{'66'}" name="submit"></td>
                        </tr>
                        $out
                        </table>
                        </center>
                        </div>
                        <input type="hidden" name="act" value="htaccess">
                        <input type="hidden" name="p" value="$passw">
                        <input type="hidden" name="l" value="h">
                        </form>
            ~;
      }
      show_html_output();
}
# **************************** SUB password ****************************
sub password
{
      my $file="data/pass.dat";
      my $mailto='wo@womail.net';
      my $old_pass=$in{'old_pass'};
      $old_pass=crypt($old_pass, substr($old_pass,-1));

      my $new_pass=$in{'new_pass'};

      if ($in{'act'} eq "ch_pass")
      {

            open (FILE, "+<$file") or die("Can't open password data file to read ",$!);
                  flock FILE,2 if $system ne "NT";
                  my $line=<FILE>;

                  if ($old_pass eq $line)
                  {
                        $line=crypt($new_pass, substr($new_pass,-1));
                  }
                  else
                  {
                        error("$error{'8'}","$error{'9'}");
                  }
                  seek FILE,0,0;
                  truncate FILE,0;
                  print FILE $line;
            close(FILE);
            print "Location:$filename?p=$line\n\n";
            exit;
      }
      else
      {
            $html_output.=qq~
                              <form method="POST" action="$filename">
                              <div align="center">
                              <center>
                              <table border="0" width="280" cellspacing="1" cellpadding="1" style="border:1px solid #687A97">
                              <tr>
                              <td colspan="2" bgcolor="#687A97" background="$setup{'non_cgi'}/bg1.gif">
                              <p align="center"><b><font color="#FFFFFF">$sign{'81'}</font></b></p>
                              </td>
                              </tr>
                              <tr>
                              <td bgcolor="#FFFFFF">$sign{'82'}</td>
                              <td bgcolor="#FFFFFF"><input type="password" name="old_pass" size="20"></td>
                              </tr>
                              <tr>
                              <td bgcolor="#FFFFFF">$sign{'83'}</td>
                              <td bgcolor="#FFFFFF"><input type="password" name="new_pass" size="20"></td>
                              </tr>
                              <tr>
                              <td bgcolor="#FFFFFF" align="center" colspan="2"><input type="submit" value="$sign{'66'}" name="submit"></td>
                              </tr>
                              </table>
                              </center>
                              </div>
                              <input type="hidden" name="act" value="ch_pass">
                              <input type="hidden" name="p" value="$passw">
                              <input type="hidden" name="l" value="p">
                              </form>
            ~;
      }
      show_html_output();
}

# *************************** SUB actions *********************** #
sub actions {
      if ($in{'a'} eq 'd'){
            open(FILE, "+<$datafd/data.data") or die("Can't open data file to update\n",$!);
                  flock FILE,2 if $system ne "NT";
                  my @data=();
                  while (<FILE>){
                        my @temp = split(/\|/,$_);
                        if ($in{'id'} eq $temp[0]){
                              next;
                        }
                        else {
                              push @data,$_;
                        }
                  }
                  seek FILE,0,0;
                  truncate FILE,0;
                  print FILE @data;
            close(FILE);
            print "Location: $filename?pg=$in{'pg'}&p=$passw\n\n";
            exit;
      }
      elsif ($in{'a'} eq 'e'){



            open (FILE, "<$datafd/data.data") or die("Can't open data file for reading\n",$!);
                  flock FILE,1 if $system ne "NT";
                  my @data = <FILE>;
            close(FILE);

            my $pg=$in{'pg'};
               $pg=1 unless ($in{'pg'});

            my($id,$name,$email,$url,$icq,$country,$city,$other1,$other2,$other3,$smile,$ip,$date,$time,$wday,$message,$admin)='';
            foreach (@data){
                  ($id)=split(/\|/,$_);
                  if ($id eq $in{'id'}){
                       ($id,$name,$email,$url,$icq,$country,$city,$other1,$other2,$other3,$smile,$ip,$date,$time,$wday,$message,$admin)=split(/\|/,$_);
                       last;
                  }
            }
            $html_output .= qq~
                  <form method="POST" action="$filename">
                  <div align="center">
                  <center>
                  <table border="0" cellpadding="0" cellspacing="1" width="90%" style="border:1px solid #687A97">
                  <tr>
                  <td width="100%" bgcolor="#" background="$setup{'non_cgi'}/bg1.gif">
                  <p align="center"><b><font color="#FFFFFF">$sign{'84'}</font></b></td>
                  </tr>
                  <tr>
                  <td width="100%" bgcolor="#FFFFFF">
                  <table border="0" cellpadding="0" cellspacing="1" width="100%">
                  <tr>
                  <td width="11%" align="right"><b>$sign{'85'}</b></td>
                  <td width="19%"><input type="text" name="name" size="20" value="$name"></td>
                  <td width="12%" align="right"><b>E-mail::</b></td>
                  <td width="20%"><input type="text" name="email" size="20" value="$email"></td>
                  <td width="12%" align="right"><b>URL::</b></td>
                  <td width="26%"><input type="text" name="url" size="20" value="$url"></td>
                  </tr>
                  <tr>
                  <td width="11%" align="right"><b>ICQ::</b></td>
                  <td width="19%"><input type="text" name="icq" size="20" value="$icq"></td>
                  <td width="12%" align="right"><b>$sign{'86'}</b></td>
                  <td width="20%"><input type="text" name="country" size="20" value="$country"></td>
                  <td width="12%" align="right"><b>$sign{'87'}</b></td>
                  <td width="26%"><input type="text" name="city" size="20" value="$city"></td>
                  </tr>
                  <tr>
                  <td width="11%" align="right"><b>Other1::</b></td>
                  <td width="19%"><input type="text" name="other1" size="20" value="$other1"></td>
                  <td width="12%" align="right"><b>Other2::</b></td>
                  <td width="20%"><input type="text" name="other2" size="20" value="$other2"></td>
                  <td width="12%" align="right"><b>Other3::</b></td>
                  <td width="26%"><input type="text" name="other3" size="20" value="$other3"></td>
                  </tr>
                  </center>
                  <tr>
                  <td width="100%" valign="top" align="right" colspan="6">
                  <table border="0" cellpadding="0" cellspacing="0" width="100%">
                  <tr>
                  <td width="49%">
                  <p align="right"><b>$sign{'88'}</b><br>
                  <textarea rows="6" name="message" cols="40">$message</textarea></td>
                  <td width="2%">
                  <p></p>
                  </td>
                  <center>
                  <td width="49%"><b>$sign{'89'}</b><br>
                  <textarea rows="6" name="reply" cols="40">$admin</textarea></td>
                  </tr>
                  </table>
                  </td>
                  </tr>
                  <tr>
                  <td width="100%" valign="top" align="center" colspan="6" bgcolor="#687A97" background="$setup{'non_cgi'}/bg1.gif">
                  <input type="submit" value="$sign{'90'}" name="submit"></td>
                  </tr>
                  </table>
                  </td>
                  </tr>
                  </table>
                  </div>
                  <input type="hidden" name="a" value="ee">
                  <input type="hidden" name="id" value="$id">
                  <input type="hidden" name="l" value="a">
                  <input type="hidden" name="smile" value="$smile">
                  <input type="hidden" name="ip" value="$ip">
                  <input type="hidden" name="date" value="$date">
                  <input type="hidden" name="time" value="$time">
                  <input type="hidden" name="wday" value="$wday">
                  <input type="hidden" name="pg" value="$pg">
                  <input type="hidden" name="p" value="$passw">
                  </form>
           ~;
           show_html_output();

      }
      elsif ($in{'a'} eq 'ee'){

            $in{'smile'}=symbols2codes($in{'smile'});

            $in{'icq'}=symbols2codes($in{'icq'});

            $in{'name'}=symbols2codes($in{'name'});

            $in{'email'} = symbols2codes($in{'email'});

            $in{'url'} = symbols2codes($in{'url'});
            $in{'url'} = email_url($in{'url'},'url');


            $in{'country'} = symbols2codes($in{'country'});
            $in{'city'} = symbols2codes($in{'city'});
            $in{'other1'} = symbols2codes($in{'other1'});
            $in{'other2'} = symbols2codes($in{'other2'});
            $in{'other3'} = symbols2codes($in{'other3'});

            $in{'message'} =~ s/^[\r\n]+//g;
            $in{'message'} =~ s/[\r\n]+$//g;
            $in{'message'} = symbols2codes($in{'message'});
            $in{'message'} =~ s|([^ \/\\\[\]]{30,}?\S)|$1 |g;

            $in{'date'} = symbols2codes($in{'date'});
            $in{'time'} = symbols2codes($in{'time'});
            $in{'wday'} = symbols2codes($in{'wday'});

            $in{'reply'} =~ s/^[\r\n]+//g;
            $in{'reply'} =~ s/[\r\n]+$//g;
            $in{'reply'} = symbols2codes($in{'reply'});

            open(FILE, "+<$datafd/data.data") or die("Can't open data file to update\n",$!);
                  flock FILE,2 if $system ne "NT";
                  my @data=();
                  while (<FILE>){
                        my @temp = split(/\|/,$_);
                        if ($in{'id'} eq $temp[0]){
                              push @data,"$in{'id'}|$in{'name'}|$in{'email'}|$in{'url'}|$in{'icq'}|$in{'country'}|$in{'city'}|$in{'other1'}|$in{'other2'}|$in{'other3'}|$in{'smile'}|$in{'ip'}|$in{'date'}|$in{'time'}|$in{'wday'}|$in{'message'}|$in{'reply'}|\n";
                        }
                        else {
                              push @data,$_;
                        }
                  }
                  seek FILE,0,0;
                  truncate FILE,0;
                  print FILE @data;
            close(FILE);
            print "Location: $filename?pg=$in{'pg'}&p=$passw\n\n";
            exit;
      }
      else {
            print "Location: $filename\n\n";
            exit;
      }

}


sub chomp_url {
    my ($the_red_sea) = @_;
    return $the_red_sea   if    $the_red_sea =~ /^<img src=/;
    return $the_red_sea unless length($the_red_sea) > 70;
    return $the_red_sea unless $the_red_sea =~ m!://!;
    # Fix up 'dem pesky ampersands
    $the_red_sea =~ s!&amp;!&!g;
    $the_red_sea =~ s!(?:(\?)|[&;])s=[\w\d]{16,32}(?:&|;|$)!$1!g;
    my ($moses, $did_indeed) = split /\:\/\//, $the_red_sea;
    my @miracle = split "/",$did_indeed;
    my $worker = substr($miracle[1], 0, 7,);
    my $maybe  = substr($miracle[$#miracle],length($miracle[$#miracle])-7);
    return $moses.'://'.$miracle[0].'/'.$worker.'....'.$maybe;
}

sub check_size{
      my $size = shift;
      unless ($size =~ /\d+/){$size = 10;}
      if ($size < 8){$size = 8;}
      if ($size > 25){$size = 25;}

      return $size;
}